/*****************************************************************************
* | File      	:	MAX7219.c
* | Author      :   Waveshare team
* | Function    :   Electronic paper driver
* | Info        :
*----------------
* |	This version:   V1.0
* | Date        :   2019-07-03
* | Info        :
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documnetation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to  whom the Software is
# furished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS OR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
******************************************************************************/
#include "MAX7219.h"
#include "Debug.h"

static void MAX7219_WriteByte(UBYTE Reg)
{
    DEV_Digital_Write(MAX7219_CS_PIN, 0);
    DEV_SPI_WriteByte(Reg);
    // DEV_Digital_Write(MAX7219_CS_PIN, 1);
}

void MAX7219_Write(UBYTE address1, UBYTE dat1, UBYTE address2, UBYTE dat2)
{
    DEV_Digital_Write(MAX7219_CS_PIN, 0);
    MAX7219_WriteByte(address1);
    MAX7219_WriteByte(dat1);
    MAX7219_WriteByte(address2);
    MAX7219_WriteByte(dat2);
    DEV_Digital_Write(MAX7219_CS_PIN, 1);
}

/******************************************************************************
function :	Initialize the e-Paper register
parameter:
******************************************************************************/
void MAX7219_Init(void)
{
    MAX7219_Write(0x09,0x00,0x09,0x00);
    MAX7219_Write(0x0a,0x03,0x0a,0x03);
    MAX7219_Write(0x0b,0x07,0x0b,0x07);
    MAX7219_Write(0x0c,0x01,0x0c,0x01);
    MAX7219_Write(0x0f,0x00,0x0f,0x00);
}
